//+------------------------------------------------------------------+
//|                                                     TreeNode.mqh |
//|                            Copyright  2015, Christopher Barklem |
//|                                            http://www.barklem.es |
//+------------------------------------------------------------------+
#property copyright "Copyright  2015, Christopher Barklem"
#property link      "http://www.barklem.es"
#property version   "1.00"
#property strict
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CTreeNode
  {
private:

public:
                     CTreeNode();
                     CTreeNode(CTreeNode* Parent,double LowPrice,double HighPrice);
                    ~CTreeNode();

   void              SetMax(double Max)               {m_Max=Max;};
   void              SetParentNode(CTreeNode *Parent) {m_ParentNode=Parent;};
   void              SetLeftNode(CTreeNode *Left)     {m_LeftNode=Left;};
   void              SetRightNode(CTreeNode *Right)   {m_RightNode=Right;};

   CTreeNode        *GetLeftNode()                    {return m_LeftNode;};
   CTreeNode        *GetRightNode()                   {return m_RightNode;};
   double            GetHighPrice()                   {return m_HighPrice;};
   double            GetLowPrice()                    {return m_LowPrice;};
   double            GetMaxPrice()                    {return m_Max;};   
   
protected:
   CTreeNode        *m_ParentNode;            // link to node up
   CTreeNode        *m_LeftNode;              // link to node left
   CTreeNode        *m_RightNode;             // link to node right

   double            m_HighPrice;
   double            m_LowPrice;
   double            m_Max;

  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CTreeNode::CTreeNode()
  {
   m_ParentNode= (CTreeNode*)NULL;
   m_LeftNode  = (CTreeNode*)NULL;
   m_RightNode = (CTreeNode*)NULL;
  }
CTreeNode::CTreeNode(CTreeNode* Parent,double LowPrice,double HighPrice)
  {
   m_ParentNode= Parent;
   m_LowPrice = LowPrice;
   m_HighPrice = HighPrice;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CTreeNode::~CTreeNode()
  {
  }
//+------------------------------------------------------------------+
